{
  Promathika - ein multifunktionales Programm zum Zeichnen von Funktionen

    Copyright (C) 2009  Arthur Schmidt, Alexander Staidl

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License Version 3 as published by
    the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
}


function tAnalyse.StrToTermtyp(Eingabe:string):PTermTyp;
var Term:PTermTyp;
    KlAuf, WN:integer;
    n,n2,laenge:dword;
    s,s2,TeilT1,TeilT2:string;
begin
  KlAuf:=0; n:=0;
  WN:=WasNun_Abl(Eingabe);
  s:=''; TeilT1:='';TeilT2:='';
  laenge:=length(Eingabe);
  new(Term);
  Term^.Konstante:=false;
  
  if WN=0 then  //add
  begin
    repeat
      TeilT1:=TeilT1+s;
      inc(n);
      s:=Eingabe[n];
      if s='(' then inc(KlAuf); if s=')' then dec(KlAuf);
    until ((KlAuf=0)and((s='+')or(s='-'))and(n<>1))or(n>=laenge);
    If (s<>'-')and(s<>'+') then TeilT1:=TeilT1+s;
    If s='-' then TeilT2:=rightstr(Eingabe,laenge-n+1) else TeilT2:=rightstr(Eingabe,laenge-n);
    
    If not((TeilT1[1]='-')and(TeilT2='')) then
    begin
      Term^.Opera:=4;                                                   //004=Addition
      Term^.Arg1:=StrToTermTyp(TeilT1);                                //Term 1. Summand
      Term^.Arg2:=StrToTermTyp(TeilT2);
    end else
    begin
      delete(TeilT1,1,1);
      Term^.Opera:=5;                                                   //Negative Zahl/Variable wird durch Multiplikation mit (-1) realisiert
      new(Term^.Arg1);
      Term^.Arg1^.Opera:=1;                                             //Wird auf (-1) gesetzt
      Term^.Arg1^.ZahlGRaZ.zaehler:=GNZeins;
      Term^.Arg1^.ZahlGRaZ.nenner:= GNZeins;
      Term^.Arg1^.GlKoZa:=-1;
      Term^.Arg1^.ZahlGRaZ.Negativ:=true;
      Term^.Arg1^.Arg1:=nil;                                            //(-1) hat keine Argumente.
      Term^.Arg1^.Arg2:=nil;
      Term^.Arg2:=StrToTermTyp(TeilT1);                                 //Nun der Term, mit dem multipliziert wird.
    end;
  end; //WN=0 add
  
  if WN=1 then  //mul
  begin
    repeat
      TeilT1:=TeilT1+s;
      inc(n);
      s:=Eingabe[n];
      if s='(' then inc(KlAuf); if s=')' then dec(KlAuf);
    until ((KlAuf=0)and((s='*')or(s='/')))or(n>=laenge);
    TeilT2:=rightstr(Eingabe,laenge-n);
    if s='/' then
    begin
      n2:=0;
      repeat
        inc(n2);
        s2:=TeilT2[n2];
        if s2='(' then inc(KlAuf); if s2=')' then dec(KlAuf);
      until ((KlAuf=0)and((s2='*')or(s2='/')))or(n2>=length(TeilT2));
      If (s2='*')or(s2='/') then
      begin
        TeilT1:=TeilT1+rightstr(TeilT2,length(TeilT2)-n2+1);
        TeilT2:=leftstr(TeilT2,n2-1);
      end;
    end;

    Term^.Opera:=5;                                                   //005=Multiplikation
    Term^.Arg1:=StrToTermTyp(TeilT1);
    If s='*' then Term^.Arg2:=StrToTermtyp(TeilT2)                   // Unterscheidung: Multiplikation/Division
     else Term^.Arg2:=StrToTermtyp('('+TeilT2+')^(-1)');
  end; //WN=1 mul
  
  if WN=2 then  //Potenz
  begin
    repeat
      TeilT1:=TeilT1+s;
      inc(n);
      s:=Eingabe[n];
      if s='(' then inc(KlAuf); if s=')' then dec(KlAuf);
    until ((KlAuf=0)and(s='^'))or(n>=laenge);
    TeilT2:=rightstr(Eingabe,laenge-n);

    Term^.Opera:=6;                                                   //006=Hoch
    Term^.Arg1:=StrToTermTyp(TeilT1);
    Term^.Arg2:=StrToTermtyp(TeilT2);
  end; //WN=2 hoch
  
  if WN=3 then  //Funktionen
  begin
    s:=midstr(Eingabe,1,3);
    if s='ln(' then
    begin
      Term^.Opera:=101;                                               //101=ln
      TeilT1:=midstr(Eingabe,4,laenge-4);
      Term^.Arg1:=StrToTermTyp(TeilT1);
      Term^.Arg2:=nil;
    end else
    begin
      s:=s+Eingabe[4];
      if s='exp(' then
      begin
        //Term^.Opera:=102;                                               //102=exp --> Wird durch _e^x ersetzt und daher nicht mehr benötigt.
        Term^.Opera:=006;
        new(Term^.Arg1);
        Term^.Arg1^.Opera:=002;                                           // Konstante '_e'
        Term^.Arg1^.Konstante:=true;
        Term^.Arg1^.Varname:='_e';
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg2:=StrToTermTyp(TeilT1);
      end else
      if s='sin(' then
      begin
        Term^.Opera:=103;                                               //103=sin
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='cos(' then
      begin
        Term^.Opera:=104;                                               //104=cos
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='tan(' then
      begin
        Term^.Opera:=105;                                               //105=tan
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='cot(' then
      begin
        Term^.Opera:=106;                                               //106=cot
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='sec(' then
      begin
        Term^.Opera:=107;                                               //107=sec
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='csc(' then
      begin
        Term^.Opera:=108;                                               //108=csc
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      if s='abs(' then
      begin
        Term^.Opera:=109;                                               //109=abs
        TeilT1:=midstr(Eingabe,5,laenge-5);
        Term^.Arg1:=StrToTermTyp(TeilT1);
        Term^.Arg2:=nil;
      end else
      begin
        s:=s+Eingabe[5];
        if s='sign(' then
        begin
          Term^.Opera:=110;                                               //110=sign
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='sinh(' then
        begin
          Term^.Opera:=111;                                               //111=sinh
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='cosh(' then
        begin
          Term^.Opera:=112;                                               //112=cosh
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='tanh(' then
        begin
          Term^.Opera:=113;                                               //113=tanh
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='coth(' then
        begin
          Term^.Opera:=114;                                               //114=coth
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='sech(' then
        begin
          Term^.Opera:=115;                                               //115=sech
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='csch(' then
        begin
          Term^.Opera:=116;                                               //116=csch
          TeilT1:=midstr(Eingabe,6,laenge-6);
          Term^.Arg1:=StrToTermTyp(TeilT1);
          Term^.Arg2:=nil;
        end else
        if s='sqrt(' then
        begin
          Term^.Opera:=006;                                               // sqrt(x) --> x^(1/2)
          Term^.Arg1:=StrToTermTyp(midstr(Eingabe,6,laenge-6));
          new(Term^.Arg2);
          Term^.Arg2^.Opera:=001;
          Term^.Arg2^.GlKoZa:=0.5;
          Term^.Arg2^.ZahlGRaZ.zaehler:=GNZeins;
          Term^.Arg2^.ZahlGRaZ.nenner:=GNZadd(GNZeins, GNZeins);
          Term^.Arg2^.ZahlGRaZ.negativ:=false;
        end else
        begin
          s:=s+Eingabe[6]+Eingabe[7];
          if s='arcsin(' then
          begin
            Term^.Opera:=117;                                               //117=arcsin
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arccos(' then
          begin
            Term^.Opera:=118;                                               //118=arccos
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arctan(' then
          begin
            Term^.Opera:=119;                                               //119=arctan
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arccot(' then
          begin
            Term^.Opera:=120;                                               //120=arccot
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arcsec(' then
          begin
            Term^.Opera:=121;                                               //121=arcsec
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arccsc(' then
          begin
            Term^.Opera:=122;                                               //122=arccsc
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arsinh(' then
          begin
            Term^.Opera:=123;                                               //123=arsinh
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arcosh(' then
          begin
           Term^.Opera:=124;                                               //124=arcosh
           TeilT1:=midstr(Eingabe,8,laenge-8);
           Term^.Arg1:=StrToTermTyp(TeilT1);
           Term^.Arg2:=nil;
          end else
          if s='artanh(' then
          begin
            Term^.Opera:=125;                                               //125=artanh
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arcoth(' then
          begin
            Term^.Opera:=126;                                               //126=arcoth
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arsech(' then
          begin
            Term^.Opera:=127;                                               //127=arsech
            TeilT1:=midstr(Eingabe,8,laenge-8); ;
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end else
          if s='arcsch(' then
          begin
            Term^.Opera:=128;                                               //128=arcsch
            TeilT1:=midstr(Eingabe,8,laenge-8);
            Term^.Arg1:=StrToTermTyp(TeilT1);
            Term^.Arg2:=nil;
          end; //not s7
        end;
      end;
    end;

  end;  //WN=3 Funktionen
  
  if WN=4 then  //Klammern
  begin
    dispose(Term);
    Term:=StrToTermtyp(midstr(Eingabe,2,laenge-2));
  end;
  
  if WN=5 then  //Zahlen, Variablen
  begin
    Term^.Arg1:=nil; Term^.Arg2:=nil;
    If IstZahl(Eingabe)=true then
    begin
      Term^.Opera:=1;                                              //001=Zahl
      laenge:=length(Eingabe);
      If laenge < 255 then Term^.GlKoZa:=StrToFloat(Eingabe) else Term^.GlKoZa:=1;  //Gleitkommazahl - StrToFloat verträgt maximal 254 Zeichen lange Zahlen.
      //BEGINN rationale Zahl
      Term^.ZahlGRaZ.Negativ:=false;
      n:=0;
      repeat
        inc(n);
        s:=Eingabe[n];
      until (s=',')or(n=laenge);
      if n=laenge then
      begin
        Term^.ZahlGRaZ.zaehler:=StrToGNZTyp(Eingabe);
        Term^.ZahlGRaZ.nenner:=GNZeins;
      end else
      begin
        //Hier muss die Kommazahl in ein Bruch umgewandelt werden:
        delete(Eingabe,n,1);
        Term^.ZahlGRaZ.zaehler:=StrToGNZTyp(Eingabe);
        s2:='1';
        for n2:=1 to laenge-n do s2:=s2+'0';
        Term^.ZahlGRaZ.nenner:=StrToGNZTyp(s2);
        //Kuerzen:
        Term^.ZahlGRaZ:=GRaZKuerzen(Term^.ZahlGRaZ);                                // Gleitkommazahlen werden automatisch gekürzt.
      end; //if n=laenge
      //ENDE rationale Zahl
    end else
    begin
      Term^.Opera:=002;                                         //002=Variable
      Term^.Varname:=Eingabe;                                   //Bezeichnung der Variablen
      If (Eingabe='_pi')or(Eingabe='_e') then Term^.Konstante:=true;
    end;
  end;
  StrToTermTyp:=Term;
end; // StrToTermtyp


function tAnalyse.TermtypToStrRek(Pointer:PTermTyp; DezimalbruchZiffAnz:word):string;
var ZwSpstr:string;
begin
  CASE Pointer^.Opera OF
    001: begin                                                                          //001=rationale Zahl
           If DezimalbruchZiffAnz=0 then
           begin                                                                        //Gibt die Zahl als Bruch (exakt) zurück.
             If (length(Pointer^.ZahlGRaZ.nenner)=1)and(Pointer^.ZahlGRaZ.nenner[0]=1)
              then Result:= GNZTypToStr(Pointer^.ZahlGRaZ.zaehler)
              else Result:=GNZTypToStr(Pointer^.ZahlGRaZ.zaehler) +'/'+
                     GNZTypToStr(Pointer^.ZahlGRaZ.nenner);
             If Pointer^.ZahlGRaZ.Negativ then Result:='-' + Result;
           end else Result:=DoubleToStr(Pointer^.GlKoZa,DezimalbruchZiffAnz);         // Gibt einen Dezimalbruch mit der angegebenen Anzahl an Ziffen zurück.
         end; // 001
    002: Result:=Pointer^.Varname;                                                      //002=Variable
    004: begin                                                                          //004=Addition
           ZwSpstr:=TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz);
           If ZwSpstr[1]='-' then Result:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +ZwSpStr{TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz)}
            else Result:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +'+'+ ZwSpStr{TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz)};
         end; // 004
    005: begin                                                                          //005=Multiplikation
           ZwSpstr:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz);
           If Pointer^.Arg1^.Opera=004 then Result:='('+ZwSpstr+')' else Result:=ZwSpstr;
           Result:=Result + '*';
           ZwSpstr:=TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz);
           If (Pointer^.Arg2^.Opera=004)or(ZwSpstr[1]='-') then Result:=Result + '(' + ZwSpstr + ')'
            else Result:=Result + ZwSpstr;
           // Sonderfallabhandlung: Entfernt 1*... bzw. -1*...
           If DezimalbruchZiffAnz=0 then
           begin
             If Pointer^.Arg1^.Opera=001 then if GNZagleichb(Pointer^.Arg1^.ZahlGRaZ.zaehler,Pointer^.Arg1^.ZahlGRaZ.nenner) then
             begin
               ZwSpstr:=TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz);
               if Pointer^.Arg1^.ZahlGRaZ.Negativ=false then Result:= ZwSpstr else
               begin
                 If Pointer^.Arg2^.Opera=004 then ZwSpStr:='(' + ZwSpStr + ')';
                 if ZwSpstr[1]<>'-' then Result:='-' + ZwSpstr else
                 begin
                   delete(ZwSpstr,1,1);                                                     // entfernt das '-'
                   Result:=ZwSpstr;
                 end;
               end;
             end else if Pointer^.Arg2^.Opera=001 then if GNZagleichb(Pointer^.Arg2^.ZahlGRaZ.zaehler,Pointer^.Arg2^.ZahlGRaZ.nenner) then
             begin
               ZwSpstr:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz);
               if Pointer^.Arg2^.ZahlGRaZ.Negativ=false then Result:= ZwSpstr else
               begin
                 If Pointer^.Arg1^.Opera=004 then ZwSpStr:='(' + ZwSpStr + ')';
                 if ZwSpstr[1]<>'-' then Result:='-' + ZwSpstr else
                 begin
                   delete(ZwSpstr,1,1);                                                     // entfernt das '-'
                   Result:=ZwSpstr;
                 end;
               end;
             end;
           end else
           begin
             If Pointer^.Arg1^.Opera=001 then
             begin
               ZwSpstr:=TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz);
               if Pointer^.Arg1^.GlKoZa=1 then Result:=ZwSpstr else if Pointer^.Arg1^.GlKoZa=-1 then
               begin
                 If Pointer^.Arg1^.Opera=004 then ZwSpStr:='(' + ZwSpStr + ')';
                 if ZwSpstr[1]<>'-' then Result:='-' + ZwSpstr else
                 begin
                   delete(ZwSpstr,1,1);                                                     // entfernt das '-'
                   Result:=ZwSpstr;
                 end;
               end;
             end else if Pointer^.Arg2^.Opera=001 then
             begin
               ZwSpstr:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz);
               If Pointer^.Arg2^.GlKoZa=1 then Result:=ZwSpStr else if Pointer^.Arg2^.GlKoZa=-1 then
               begin
                 If Pointer^.Arg1^.Opera=004 then ZwSpStr:='(' + ZwSpStr + ')';
                 if ZwSpstr[1]<>'-' then Result:='-' + ZwSpstr else
                 begin
                   delete(ZwSpstr,1,1);                                                     // entfernt das '-'
                   Result:=ZwSpstr;
                 end;
               end;
             end; // Arg^.Opera=001
           end; // if DezimalbruchZiffAnz = 0 else
         end; // 005
    006: begin                                                                          //006=Potenz
           Result:='';
           ZwSpstr:=TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz);
           If Pointer^.Arg2^.Opera=001 then                                             // Alias: x^(1/2) --> sqrt(x)
           begin
             if (length(Pointer^.Arg2^.ZahlGRaZ.zaehler)=1)and(Pointer^.Arg2^.ZahlGRaZ.zaehler[0]=1)and(length(Pointer^.Arg2^.ZahlGRaZ.nenner)=1)
              and(Pointer^.Arg2^.ZahlGRaZ.nenner[0]=2)and(Pointer^.Arg2^.ZahlGRaZ.Negativ=false) then
             Result:='sqrt('+ZwSpstr+')';
           end;
           If Result='' then
           begin
             If (Pointer^.Arg1^.Opera=002)or((Pointer^.Arg1^.Opera=001)and(ZwSpstr[1]<>'-')and(GNZagleichb(Pointer^.Arg1^.ZahlGRaZ.Nenner,1))) then Result:=ZwSpstr
              else Result:='(' + ZwSpstr + ')';
             Result:=Result + '^';
             ZwSpstr:=TermtypToStrRek(Pointer^.Arg2,DezimalbruchZiffAnz);
             If (Pointer^.Arg2^.Opera=002)
              or ((DezimalbruchZiffAnz=0)and(Pointer^.Arg2^.Opera=001)and(Pointer^.Arg2^.ZahlGRaZ.Negativ=false)and(length(Pointer^.Arg2^.ZahlGRaZ.nenner)=1)and(Pointer^.Arg2^.ZahlGRaZ.nenner[0]=1))
              or ((DezimalbruchZiffAnz>0)and(Pointer^.Arg2^.Opera=001)and(Pointer^.Arg2^.GlKoZa>0))
              or ((Pointer^.Arg2^.Opera>100)and(Pointer^.Arg2^.Opera<129)) then Result:=Result + ZwSpstr
              else Result:=Result + '(' + ZwSpstr + ')';
           end;
         end; // 006
    101: Result:='ln('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                               //101=ln
 // 102: Entfällt, da exp(x) durch _e^x ersetzt wurde.
    103: Result:='sin('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //103=sin
    104: Result:='cos('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //104=cos
    105: Result:='tan('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //105=tan
    106: Result:='cot('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //106=cot
    107: Result:='sec('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //107=sec
    108: Result:='csc('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //108=csc
    109: Result:='abs('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                              //109=abs
    110: Result:='sign('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //110=sign
    111: Result:='sinh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //111=sinh
    112: Result:='cosh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //112=cosh
    113: Result:='tanh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //113=tanh
    114: Result:='coth('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //114=coth
    115: Result:='sech('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //115=sech
    116: Result:='csch('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                             //116=csch
    117: Result:='arcsin('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //117=arcsin
    118: Result:='arccos('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //118=arccos
    119: Result:='arctan('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //119=arctan
    120: Result:='arccot('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //120=arccot
    121: Result:='arcsec('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //121=arcsec
    122: Result:='arccsc('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //122=arccsc
    123: Result:='arsinh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //123=arsinh
    124: Result:='arcosh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //124=arcosh
    125: Result:='artanh('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //125=artanh
    126: Result:='arcoth('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //126=arcoth
    127: Result:='arsech('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //127=arsech
    128: Result:='arcsch('+ TermtypToStrRek(Pointer^.Arg1,DezimalbruchZiffAnz) +')';                           //128=arcsch
  end;
end; // TermtypToStrRek


function tAnalyse.TermTypToStr(var Pointer:PTermTyp;DezimalbruchZiffAnz:word):string;
begin
  If DezimalbruchZiffAnz=0 then RESULT:=TermTypToStrRek(Pointer,0) else if DezimalbruchZiffAnz<=16 then
  begin
    Dezimalisierung(Pointer);
    RESULT:=TermTypToStrRek(Pointer,DezimalbruchZiffAnz);
  end else Err:=18;
end; //TermTypToStr


function tAnalyse.StrToGNZTyp(Eingabe:string):GNZTyp;
var ZwSp:word;
    n:dword;
    Erg:GNZTyp;
begin
  setlength(Erg,length(Eingabe));
  for n := 1 to length(Eingabe) do
  begin
    ZwSp := ord(Eingabe[n]);
    If (ZwSp>=48)and(ZwSp<=57) then Erg[length(Eingabe)-n] := ZwSp-48 else begin
      Err:=7;
      setlength(Erg,1);
      Erg[0]:=1;       // um Division durch 0 vorzubeugen.
    end;
  end;
  Result := GNZBasisDezToGlobB(Erg);
end;  //StrToGNZTypDez


function tAnalyse.GNZTypToStr(Eingabe:GNZTyp):string;
var n: dword;
    Ausgabe: string;
begin
  Ausgabe := '';
  Eingabe:=GNZGlobBToBasisDez(Eingabe);
  for n:=1 to length(Eingabe) do Ausgabe:=Ausgabe + chr(Eingabe[length(Eingabe)-n]+48);
  Result:=Ausgabe;
end;  //GNZTypDezToStr


function tAnalyse.GRaZTypToDouble(Eingabe:GRaZTyp):double;
var n:dword;
    Zaehler, Nenner:double;
begin
  // HINWEIS: Muss noch gegen zu große Zahlen für Zaehler, Nenner (außerhalb des double-Bereichs) abgesichert werden.
  If length(Eingabe.Zaehler)=0 then Err:=17 else
  begin
    Zaehler:=0; Nenner:=0;
    for n:= 0 to length(Eingabe.Zaehler)-1 do Zaehler:=Zaehler + Eingabe.Zaehler[n]*power(GNZ_GlobZahlenbasis,n);
    for n:= 0 to length(Eingabe.Nenner)-1 do Nenner:=Nenner + Eingabe.Nenner[n]*power(GNZ_GlobZahlenBasis,n);
    If Eingabe.Negativ then Zaehler:=Zaehler*(-1);
    RESULT:=Zaehler/Nenner;
  end;
end; // GRaZTypToDouble


function tAnalyse.DoubleToStr(Eingabe:double;ZifferAnz:word):string;
var EPos:word;
begin
  RESULT:=FloatToStrF(Eingabe,ffGeneral,ZifferAnz,0);
  //Nun muss ein möglicherweise enthaltenes E durch *10^() ersetzt werden.
  EPos:=pos('E',RESULT);
  If EPos>0 then
  begin
    delete(RESULT,EPos,1);
    If RESULT[EPos]<>'-' then insert('*10^',RESULT,EPos) else
    begin
      insert('*10^(',RESULT,EPos);
      RESULT:=RESULT + ')';
    end;
  end; // if EPos>0
end; // DoubleToStr


function tAnalyse.GRaZTypToStr(Eingabe:GRaZTyp;ZifferAnz:word):string;
begin
  RESULT:=DoubleToStr(GRaZTypToDouble(Eingabe),ZifferAnz);
end; // GRaZTypToStr
